/* Variable definitions for NoImake */
/* Martin Karrenbach   8-25-92     */
/* Solaris support (-DSUN5) added 8-22-95 */

#if defined(SUN5) || defined(SUN4)
HOME		= /usr/openwin
#else
HOME            =/usr/local/X11R6
#endif

BINDIR          =${HOME}/bin
MANDIR          =${HOME}/man
USRLIBDIR       =${HOME}/lib
LIBDIR          =${USRLIBDIR}
INCDIR          =${HOME}/include

#if defined(HP700)
LIBDIR          =/usr/lib/X11R5
#endif

RESOURCES       =${LIBDIR}/app-defaults
APPDEFAULTS     =Xtpanel

/* you normally should not have to modify below here, unless you add */
/* specific options for new machines                                 */

SUBDIRS = help generator examples tutor

#if defined(SUN5)
/* build on Solaris using gcc */
/*CC		= gcc -U__STDC__ -DSVR4 */
CC		= cc -DSVR4 
CPP		= /usr/ccs/lib/cpp
#else
CPP             = /lib/cpp
#endif

CCOPTIONS       = -O

#if defined(SUN4)
CCOPTIONS       = -O 
#endif

#if defined(HP700)
CCOPTIONS       = -O -Aa -D_HPUX_SOURCE
#endif

STD_DEFINES    = -D_NO_PROTO 

#if defined(RS6000)
STD_DEFINES    = -DSYSV -DAIXV3
#endif

EXTRA_DEFINES  = -DSYS_XTPANELDIR=\"$(SYS_XTPANELDIR)\" 

STD_INCLUDES   = -I$(INCDIR) -I.

XAWCLIENTLIBS  = $(XPMLIB) -lXaw -lXmu -lXt -lXext -lX11

INCLUDES =  $(EXTRA_INCLUDES) $(STD_INCLUDES)
DEFINES  =  $(STD_DEFINES)    $(EXTRA_DEFINES) 

#if defined(SUN4)
STATIC	 =  -Bdynamic -ldl -Bstatic
CFLAGS  = -Bstatic $(CDEBUGFLAGS) $(CCOPTIONS) $(DEFINES) $(INCLUDES) $(STATIC)
#else
STATIC	 =  
CFLAGS  = $(CDEBUGFLAGS) $(CCOPTIONS) $(DEFINES) $(INCLUDES) $(STATIC)
#endif

#if defined(SUN5)
EXTRA_LIBRARIES = -lsocket -lnsl 
#endif

SYSLIBS = $(SYS_LIBRARIES) $(EXTRA_LIBRARIES)

LDOPTIONS = $(CDEBUGFLAGS) $(CCOPTIONS) $(LOCAL_LDFLAGS) -L$(LIBDIR) \
            -L$(USRLIBDIR) $(LIBS)

RM      =  /bin/rm -f *.o core

RM_CMD      =  /bin/rm -f

INSTALL = install

MKDIRHIER = mkdirhier

/* all makefiles will have these rules  */
all::

clean::
	$(RM_CMD) "#"*

