#ifndef BUILDERS_H
#define BUILDERS_H

#include <X11/Intrinsic.h>
#include "tree.h"

typedef struct compositeinfo {
    Widget topwidget;
    Widget hidewidget;
    Widget insert_position;
} _cominf;

#if ( defined(__STDC__) || defined(FUNCPROTO) ) && !defined(_NO_PROTO)

extern void build_message( entry*, Objdef* );
extern void build_button( entry*, Objdef*, char* );
extern void build_slider( entry*, Objdef*, char* );
extern void build_dialog( entry*, Objdef* );
extern void build_text( entry*, Objdef*, char* );
extern void build_menubutton( entry*, Objdef* );
extern void build_list( entry*, Objdef* );
extern void build_choice( entry*, Objdef* );
extern void build_variable( entry*, Objdef*, char* );
extern void build_graph( entry*, Objdef* );
extern void build_grid( entry*, Objdef*, char* );
extern void build_timer( entry*, Objdef* );
extern void build_input( entry*, Objdef*, char* );
extern void build_box(entry*, Objdef*, char*);
extern void build_form(entry*, Objdef*, char*);
extern void build_window(entry*, Objdef*, int );


extern int SetTag( Widget, Arg*, int*, char*, char* );
extern void common_tags( Widget, entry*, Arg*, int*, int );
extern int update_common_tag( Objdef*, char*, char* );

#else

extern void build_message();
extern void build_button();
extern void build_slider();
extern void build_dialog();
extern void build_text();
extern void build_menubutton();
extern void build_list();
extern void build_choice();
extern void build_variable();
extern void build_graph();
extern void build_grid();
extern void build_timer();
extern void build_input();
extern void build_box();
extern void build_form();
extern void build_window();

extern void common_tags();
extern int SetTag();
extern int update_common_tag();

#endif

#define SET_SIZE 1
#define SET_POSITION 2
#define SET_ORIENT 4
#define SET_COLOR 8
#define SET_FONT 16
#define SET_BITMAP 32
#define SET_EDIT 64
#define SET_FORM 128
#define SET_STATE 256
#define SET_PIXMAP 512
#define SET_BEFORE 1023
#define SET_AFTER 1024
#define SET_ALL 2047

#endif
