/*
 * Copyright 1992, 1993, 1994 The Board of Trustees of the Leland Stanford
 * Junior University. Copyright 1994, 1995 Dave Nichols and Steve Cole.
 * Permission is hereby given to use, copy, modify, and
 * distribute this software, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * STANFORD AND THE AUTHORS MAKE NO REPRESENTATIONS OR WARRANTIES OF ANY 
 * KIND CONCERNING  THIS SOFTWARE.
 */


/*
 *
 *  source file:   ./xtpanel/message.c
 *
 * Steve Cole, Dave Nichols (SEP), August 28 1992
 *      Inserted this sample edit history entry.
 *      Please log any further modifications made to this file:
 */

#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Label.h>
#include <assert.h>

#include "object.h"
#include "tree.h"
#include "builders.h"

void build_message(root,parent)
     entry *root;
     Objdef* parent;
{
    Objdef *object;
    Widget message;
    Arg args[20];
    int narg;
    char defname[12];
    static int numess=1;
    extern void message_update();
    
    /* create new object */
    object = new_object(parent);

    /* construct default dialog name */
    sprintf(defname,"message%d",numess++);
    
    /* find label, name in tree */
    object->name = get_value(root,"name",defname);
    object->value = get_value(root,"value","");

    /* messages do not have a border drawn around them */
    narg = 0;
    XtSetArg(args[narg], XtNborderWidth, 0); narg++;
    XtSetArg(args[narg], XtNlabel, object->value); narg++;
    /* common parameters */
    common_tags(parent->widgetname,root,args,&narg,SET_BEFORE);

    assert( narg < 20 );    
    message = XtCreateManagedWidget(object->name,labelWidgetClass,
					parent->widgetname,args,narg);

    object->widgetname = message;
    object->updater = message_update;

    /* now hide object if needed */
    narg = 0;
    common_tags(message,root,args,&narg,SET_AFTER);
}

void message_update(object,value)
Objdef* object;
char* value;
{
    Arg args[20];
    int narg;

    narg = 0;
    XtSetArg(args[narg], XtNlabel, value); narg++;
    XtSetValues(object->widgetname,args,narg);
}

