
#ifndef OBJECT_H
#define OBJECT_H

#include <X11/Intrinsic.h>

#include "actions.h"

typedef struct objdef {
	char* name;
	action* action;
	char* value;
	Widget widgetname;
	Widget childwidget;
	void* info;
	void (*updater)();
	void (*sync)();
	void (*destroy)();
	void (*tab_proc)();
	char* tab;
	struct objdef* parent;
	struct objdef* child1;
	struct objdef* next_sib;
	} Objdef, *PObjdef; 

#if ( defined(__STDC__) || defined(FUNCPROTO) ) && !defined(_NO_PROTO)

extern Objdef* new_object();
extern Objdef* find_by_name( char*);
extern Objdef* find_by_widget( Widget );
extern char* get_string( char* );
extern int set_string( char*, char* );
extern void all_actions(void);
extern int update_object(char*,char*);
extern int update_tag(char*,char*,char*);
extern int destroy_object(char*);
extern int create_object(char*,char*);


#else

extern Objdef* new_object();
extern Objdef* find_by_name();
extern Objdef* find_by_widget();
extern char* get_string();
extern int set_string();
extern void all_actions();
extern int update_object();
extern int update_tag();
extern int destroy_object();
extern int create_object();


#endif

#endif
