/*
 * Copyright 1992, 1993, 1994 The Board of Trustees of the Leland Stanford
 * Junior University. Copyright 1994, 1995 Dave Nichols and Steve Cole.
 * Permission is hereby given to use, copy, modify, and
 * distribute this software, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * STANFORD AND THE AUTHORS MAKE NO REPRESENTATIONS OR WARRANTIES OF ANY 
 * KIND CONCERNING  THIS SOFTWARE.
 */


/*
 *
 *  source file:   ./xtpanel/tabbing.c
 *
 * Steve Cole, Dave Nichols (SEP), August 28 1992
 *      Inserted this sample edit history entry.
 *      Please log any further modifications made to this file:
 * Steve Cole, Dave Nichols (SEP), November 1 1993
 *      wrote tabbing.c.
 */

/*   
 *   Add a tab_next callback that goes to the specified object.
 *
 */
#include <stdio.h>
#include <string.h>

#include "object.h"

void tab_next_callback( w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal *num_params;
{
    Objdef* object, *newobject;
    object = find_by_widget(w);
    if (object->tab != 0) {
	newobject = find_by_name(object->tab);

        if( newobject->tab_proc != 0 ){
	    newobject->tab_proc ( newobject );
	}else{

    	if (newobject->widgetname != 0 && XtIsManaged(newobject->widgetname) )
                XWarpPointer(XtDisplay(newobject->widgetname),None,
			XtWindow(newobject->widgetname),0,0,0,0,5,5);
        }
    }
}
