
#include "patchlevel.h"
#include "user_func.h"
#include "expand_string.h"
#include "object.h"

/* This type of user function takes three arguments
  1) The name of the  object that calls the action
  2) A string (the string in the action)
  3) The callback data that was passed when the object was registered


  This example function just prints its name, string 
  and its callback data (assumed int)

 */
  
void my_userfunc1( char* myname, char* string, void* userdata ){

fprintf(stderr,"myname = %s \n",myname);
fprintf(stderr,"string = %s \n",string);
fprintf(stderr,"callback = %d \n",*((int*)userdata) );

}

/* This type of user function takes four arguments
  1) The name of the  object that calls the action
  1) The name of a target object
  2) A string (the string in the action)
  3) The callback data that was passed when the object was registered

  This example function just does the same as assign, it calls the
  function update_object to change the target objects value

*/

void my_userfunc2( char* myname, char* toname, char* string, void* userdata ){

fprintf(stderr,"myname = %s \n",myname);
fprintf(stderr,"toname = %s \n",toname);
fprintf(stderr,"string = %s \n",string);
	
update_object( toname, string );

}
    
int main(argc,argv)
     
     int argc;
     char **argv;
{

int one=1,two=2;
       
    add_function1("myfunc1",my_userfunc1,&one);
    add_function1("myfunc2",my_userfunc1,&two);

    add_function2("myassign",my_userfunc2,0);

    xtp_init_app( argc, argv );

}
