#ifndef TREE_H
#define TREE_H

#include <X11/Intrinsic.h>

#if defined __STDC__ || defined __stdc__ 
#include <stdlib.h>
#else
#if defined AIXV3 || defined sun || defined ultrix
#include <stdlib.h>
#else
extern double atof();
#endif
#endif

#include <string.h>

#define ALPHNUM \
   "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890"

struct _ent {
        char* tag;
	char* value;
	struct _ent* child;
	struct _ent* next;
} ;

typedef struct _ent entry;

#if ( defined(__STDC__) || defined(FUNCPROTO) ) && !defined(_NO_PROTO)
#include <stdio.h>
extern entry* new_entry( char*, int);
extern void delete_entry(entry*);
extern void add_child( entry*, entry* );
extern void add_sibling( entry*, entry* );
extern char* get_value( entry*, char*, char*);
extern char* get_raw_value( entry*, char*, char*);
extern char* get_name( entry*, char* );
extern entry* get_next(entry*, char*, entry* );
extern entry* get_next_act_or_test(entry*, entry*);
extern entry* copy_tree(entry*);
extern void print_entry( FILE*, entry*, int );
extern int is_specified( entry*,  char* );

#else
extern entry* new_entry();
extern void delete_entry();
extern void add_child();
extern void add_sibling();
extern char* get_value();
extern char* get_raw_value();
extern char* get_name();
extern entry* get_next();
extern entry* get_next_act_or_test();
extern void print_entry();
extern entry* copy_tree();
extern int is_specified();
#endif

#endif
