/*
 * Copyright 1992, 1993, 1994 The Board of Trustees of the Leland Stanford
 * Junior University. Copyright 1994, 1995 Dave Nichols and Steve Cole.
 * Permission is hereby given to use, copy, modify, and
 * distribute this software, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * STANFORD AND THE AUTHORS MAKE NO REPRESENTATIONS OR WARRANTIES OF ANY 
 * KIND CONCERNING  THIS SOFTWARE.
 */


/*
 *
 * source file:   ./xtpanel/user_func.c
 *
 * Dave Nichols (SEP), Feb 7 1994
 *      Inserted this sample edit history entry.
 *      Please log any further modifications made to this file:
 */

#include <stdio.h>


#include "object.h"
#include "tree.h"
#include "builders.h"

#include "user_func.h"

/* define a head of list of user functions */
static user_fn* funclist = 0;

static user_fn * new_func( fname )
char* fname;
{
user_fn *curr,*prev;
user_fn *new_fn;

  prev =0;

  for( curr = funclist; curr != 0 ; prev=curr, curr=curr->next_fn ){
     if( !strcmp( fname, curr->name ) ) {
        fprintf(stderr,"Attempt to add second user function called %s\n",fname);
        fprintf(stderr,"User function names must be unique\n");
        exit(-1);
     }
  }
  /* now prev points at the tail of the list  or zero if the list is empty */

  /* make a new structure */
  new_fn = (user_fn *)XtMalloc(sizeof( user_fn ) );
  new_fn->name=XtNewString(fname);
  new_fn->type=0;
  new_fn->func1=0;
  new_fn->func2=0;
  new_fn->user_data=0;
  new_fn->next_fn=0;

  if (prev == 0 ){
      funclist = new_fn;
  }else{
      prev->next_fn = new_fn;
  }

  return new_fn;
}


/* Add a new user function of type 1 */
#if ( defined(__STDC__) || defined(FUNCPROTO) ) && !defined(_NO_PROTO)
void add_function1(char* fname, user_func1 func1 ,void* user_data )
#else
void add_function1( fname, func1 , user_data )
char* fname; 
user_func1 func1 ;
void* user_data ;
#endif
{
user_fn *new_fn;

new_fn = new_func( fname );
new_fn->type = 1;
new_fn->func1 = func1;
new_fn->user_data = user_data;

}


/* Add a new user function of type 2 */
#if ( defined(__STDC__) || defined(FUNCPROTO) ) && !defined(_NO_PROTO)
void add_function2(char* fname ,user_func2 func2 ,void* user_data )
#else
void add_function2( fname ,func2 , user_data )
char* fname; 
user_func2 func2 ;
void* user_data ;
#endif
{
user_fn *new_fn;

new_fn = new_func( fname );
new_fn->type = 2;
new_fn->func2 = func2;
new_fn->user_data = user_data;
}


#if ( defined(__STDC__) || defined(FUNCPROTO) ) && !defined(_NO_PROTO)
struct user_function* find_function(char* fname)
#else
struct user_function* find_function(fname)
char* fname;
#endif
{
user_fn* curr;

for( curr = funclist; curr != 0 ; curr=curr->next_fn ){
   if( !strcmp( fname, curr->name ) ) return curr;
}

return 0;
}
