
#ifndef USERFN_H
#define USERFN_H

#include <X11/Intrinsic.h>

/* a user function can take one of two forms, 
 * the first form is passed the current object the string and the user data 
 * the second form is passed a destination object as well.
 */

#if ( defined(__STDC__) || defined(FUNCPROTO) ) && !defined(_NO_PROTO)
typedef void (*user_func1)(char*,char*,void*);
typedef void (*user_func2)(char*,char*,char*,void*);
#else
typedef void (*user_func1)();
typedef void (*user_func2)();
#endif

typedef struct user_function {
	char* name;
	int type;
	user_func1 func1;
	user_func2 func2;
        void* user_data;
	struct user_function* next_fn;
} user_fn ;

#if ( defined(__STDC__) || defined(FUNCPROTO) ) && !defined(_NO_PROTO)

/* a user function is created using a name and a function pointer,
   and a pointer to the user data */
extern void add_function1(char*,user_func1,void*);
extern void add_function2(char*,user_func2,void*);
extern struct user_function* find_function(char*);

#else

extern void add_function1();
extern void add_function2();
extern struct user_function* find_function();

#endif

#endif
